/*
 * Copyright 2002 Barnaba Marcello <vjt@azzurra.org>
 * 
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 
 * 2a. Redistributions in binary form must reproduce the above copyright
 *     notice, this list of conditions and the following disclaimer in
 *     the documentation and/or other materials provided with the
 *     distribution.
 * 2b. Redistribution in binary form requires specific prior written
 *     authorization of the maintainer.
 * 
 * 3. All advertising materials mentioning features or use of this
 *    software must display the following acknowledgement:
 *    This product includes software developed by Barnaba Marcello.
 * 
 * 4. The names of the maintainer, developers and contributors may not be
 *    used to endorse or promote products derived from this software
 *    without specific prior written permission.
 * 
 * THIS SOFTWARE IS PROVIDED BY THE MAINTAINER, DEVELOPERS AND
 * CONTRIBUTORS "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING,
 * BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND
 * FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.  IN NO EVENT SHALL
 * THE DEVELOPERS OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT,
 * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING,
 * BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
 * LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER
 * CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN
 * ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
 * POSSIBILITY OF SUCH DAMAGE.
 */

/* $Id: conf.h,v 1.10 2003/03/23 18:50:38 vjt Exp $ */

#ifndef __conf_h__
#define __conf_h__

enum
{
    SYMBOL_SECTION_START = G_TOKEN_LAST + 1,
    SYMBOL_SECTION_END,
    SYMBOL_SECTION_MAIN,
    SYMBOL_SECTION_SQL,
    
    SYMBOL_SECTION_CHANSERV,
    SYMBOL_SECTION_NICKSERV,
    SYMBOL_SECTION_OPERSERV,
    SYMBOL_SECTION_ROOTSERV,
    SYMBOL_SECTION_MEMOSERV,
    SYMBOL_SECTION_NOTICER,

    SYMBOL_SECTION_MODULES,

    /* main { */
    SYMBOL_MY_NAME,
    SYMBOL_MY_PASS,
    SYMBOL_MY_INFO,

    SYMBOL_UPLINK_PASS,
    SYMBOL_UPLINK_HOST,
    SYMBOL_UPLINK_PORT,
    SYMBOL_UPLINK_NAME,

    /* } */
    /* agent { */
    SYMBOL_AGENT_NAME,
    SYMBOL_AGENT_USERNAME,
    SYMBOL_AGENT_HOST,
    SYMBOL_AGENT_INFO,
    /* } */

    /* sql { */
    SYMBOL_SQL_HOST,
    SYMBOL_SQL_USER,
    SYMBOL_SQL_PASS,
    SYMBOL_SQL_DB,
    SYMBOL_SQL_PORT,
    /* } */

    /* modules { */
    SYMBOL_MODULE_LOAD
    /* } */
};
#define FIRST_SECTION_SYMBOL	SYMBOL_SECTION_START
#define LAST_SECTION_SYMBOL	SYMBOL_SECTION_MODULES

enum
{
    SCOPE_FILE = 1,
    SCOPE_MAIN_SECTION,
    SCOPE_AGENT_SECTION,
    SCOPE_SQL_SECTION,
    SCOPE_MODULES_SECTION
};

typedef struct config_item ConfigItem;
struct config_item
{
    guint id;
    gchar *value;
};

void setup_configuration(void);
gchar *find_conf_id(GNode *root, guint id);
GNode *find_section_id(guint id);

#define SUX_CONFIG_FILE		ETCDIR "/sux.conf"
#define SUX_MODULES_DIR		LIBDIR

#endif /* __conf_h__ */
