/*
 * Copyright 2002 Barnaba Marcello <vjt@azzurra.org>
 * 
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 
 * 2a. Redistributions in binary form must reproduce the above copyright
 *     notice, this list of conditions and the following disclaimer in
 *     the documentation and/or other materials provided with the
 *     distribution.
 * 2b. Redistribution in binary form requires specific prior written
 *     authorization of the maintainer.
 * 
 * 3. All advertising materials mentioning features or use of this
 *    software must display the following acknowledgement:
 *    This product includes software developed by Barnaba Marcello.
 * 
 * 4. The names of the maintainer, developers and contributors may not be
 *    used to endorse or promote products derived from this software
 *    without specific prior written permission.
 * 
 * THIS SOFTWARE IS PROVIDED BY THE MAINTAINER, DEVELOPERS AND
 * CONTRIBUTORS "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING,
 * BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND
 * FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.  IN NO EVENT SHALL
 * THE DEVELOPERS OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT,
 * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING,
 * BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
 * LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER
 * CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN
 * ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
 * POSSIBILITY OF SUCH DAMAGE.
 */

/* $Id: operserv.h,v 1.10 2003/03/25 01:49:42 vjt Exp $ */

#ifndef __operserv_h__
#define __operserv_h__

#include "sux.h"

gboolean operserv(User *, gchar *);

void os_help(User *, gint, gchar **);
void os_find(User *, gint, gchar **);
void os_stats(User *, gint, gchar **);
void os_uptime(User *, gint, gchar **);
void os_version(User *, gint, gchar **);
void os_global(User *, gint, gchar **);
void os_map(User *, gint, gchar **);
void os_akill(User *, gint, gchar **);

void os_akill_add(User *, gint , gchar **);
void os_akill_del(User *, gint , gchar **);
void os_akill_list(User *, gint , gchar **);
void os_akill_perm(User *, gint , gchar **);
void os_akill_time(User *, gint , gchar **);
void os_akill_id(User *, gint , gchar **);

void os_akill_db_synch(void);

typedef struct
{
    gchar *user;
    gchar *host;
    gint id;
    time_t expire_at;
    GSource *timeout;
} AKill;

#endif
